//event.h 


//This is stuff to translate key codes to VS codes.  There are two tables, for shifted
//and unshifted.  The base is 0x41, the code for the keypad period.  The max is 0x7e, the
//code for the up arrow.  This includes everything but the main portion of the keyboard.

unsigned char kpxlate[2][62] =
  {
	  {		/* virtual key code */
		VSKP,	/* $41 */
		VSRT,	/* $42 (Mac+) */
		VSF4,	/* $43 (ADB) */
		0,		/* $44 */
		VSKC,	/* $45 (ADB std) */
		VSLT,	/* $46 (Mac+) */
		VSF1,	/* $47 */
		VSDN,	/* $48 (Mac+) */
		0,		/* $49 */
		0,		/* $4A */
		VSF3,	/* $4B (ADB) */
		VSKE,	/* $4C */
		VSUP,	/* $4D (Mac+) */
		VSKM,	/* $4E */
		0,		/* $4F */
		0,		/* $50 */
		VSF2,	/* $51 (ADB) */
		VSK0,	/* $52 */
		VSK1,	/* $53 */
		VSK2,	/* $54 */
		VSK3,	/* $55 */
		VSK4,	/* $56 */
		VSK5,	/* $57 */
		VSK6,	/* $58 */
		VSK7,	/* $59 */
		0,		/* $5A */
		VSK8,	/* $5B */
		VSK9,	/* $5C */
		0,		/* $5D */
		0,		/* $5E */
		0,		/* $5F */
		VSF10,	/* $60 */	/* BYU 2.4.12 */
		VSF11,	/* $61 */	/* BYU 2.4.12 */
		VSF12,	/* $62 */	/* BYU 2.4.12 */
		VSF8,	/* $63 */	/* BYU 2.4.12 - was VSF3 */
		VSF13,	/* $64 */	/* BYU 2.4.12 */
		VSF14,	/* $65 */	/* BYU 2.4.12 */
		0,		/* $66 */
		VSF16,	/* $67 */	/* BYU 2.4.12 */
		0,		/* $68 */
		VSF18,	/* $69 */	/* BYU 2.4.12 */
		0,		/* $6A */
		VSF19,	/* $6B */	/* BYU 2.4.12 */
		0,		/* $6C */
		VSF15,	/* $6D */	/* BYU 2.4.12 */
		0,		/* $6E */
		VSF17,	/* $6F */	/* BYU 2.4.12 */
		0,		/* $70 */
		VSF20,	/* $71 */	/* BYU 2.4.12 */
		VSHELP,	/* $72 */	/* BYU 2.4.12 */
		VSHOME,	/* $73 */	/* BYU 2.4.12 */
		VSPGUP,	/* $74 */	/* BYU 2.4.12 */
		VSDEL,	/* $75 (ADB ext) */		/* BYU 2.4.12 - was 0x7f */
		VSF9,	/* $76 */	/* BYU 2.4.12 - was VSF4 */
		VSEND,	/* $77 */	/* BYU 2.4.12 */
		VSF7,	/* $78 */	/* BYU 2.4.12 - was VSF2 */
		VSPGDN,	/* $79 */	/* BYU 2.4.12 */
		VSF6,	/* $7A */	/* BYU 2.4.12 - was VSF1 */
		VSLT,	/* $7B */
		VSRT,	/* $7C */
		VSDN,	/* $7D */
		VSUP	/* $7E */
	  },
	  {
		VSKP,	/* $41 */
		VSF4,	/* $42 (Mac+) */
		VSF4,		/* $43 (ADB) */
		0,		/* $44 */
		VSKC,		/* $45 (ADB) */
		VSKC,	/* $46 (Mac+) */
		VSF1,	/* $47 */
		VSF2,	/* $48 */
		0,		/* $49 */
		0,		/* $4A */
		VSF3,		/* $4B */
		VSKE,	/* $4C */
		VSF3,	/* $4D */
		VSKM,		/* $4E */
		0,		/* $4F */
		0,		/* $50 */
		VSF2,		/* $51 */
		VSK0,	/* $52 */
		VSK1,	/* $53 */
		VSK2,	/* $54 */
		VSK3,	/* $55 */
		VSK4,	/* $56 */
		VSK5,	/* $57 */
		VSK6,	/* $58 */
		VSK7,	/* $59 */
		0,		/* $5A */
		VSK8,	/* $5B */
		VSK9,	/* $5C */
		0,		/* $5D */
		0,		/* $5E */
		0,		/* $5F */
		VSF10,	/* $60 */	/* BYU 2.4.12 */
		VSF11,	/* $61 */	/* BYU 2.4.12 */
		VSF12,	/* $62 */	/* BYU 2.4.12 */
		VSF8,	/* $63 */	/* BYU 2.4.12 - was VSF3 */
		VSF13,	/* $64 */	/* BYU 2.4.12 */
		VSF14,	/* $65 */	/* BYU 2.4.12 */
		0,		/* $66 */
		VSF16,	/* $67 */	/* BYU 2.4.12 */
		0,		/* $68 */
		VSF18,	/* $69 */	/* BYU 2.4.12 */
		0,		/* $6A */
		VSF19,	/* $6B */	/* BYU 2.4.12 */
		0,		/* $6C */
		VSF15,	/* $6D */	/* BYU 2.4.12 */
		0,		/* $6E */
		VSF17,	/* $6F */	/* BYU 2.4.12 */
		0,		/* $70 */
		VSF20,	/* $71 */	/* BYU 2.4.12 */
		VSHELP,	/* $72 */	/* BYU 2.4.12 */
		VSHOME,	/* $73 */	/* BYU 2.4.12 */
		VSPGUP,	/* $74 */	/* BYU 2.4.12 */
		VSDEL,	/* $75 (ADB ext) */		/* BYU 2.4.12 - was 0x7f */
		VSF9,	/* $76 */	/* BYU 2.4.12 - was VSF4 */
		VSEND,	/* $77 */	/* BYU 2.4.12 */
		VSF7,	/* $78 */	/* BYU 2.4.12 - was VSF2 */
		VSPGDN,	/* $79 */	/* BYU 2.4.12 */
		VSF6,	/* $7A */	/* BYU 2.4.12 - was VSF1 */
		VSLT,	/* $7B */
		VSRT,	/* $7C */
		VSDN,	/* $7D */
		VSUP	/* $7E */
	  }
  };
  
  /* ASCII character set defines */

#define DELchar		0x7f	/* BYU LSC - (DEL is defined in MacLook.h) the delete character */
#define	KILLCHAR	0x15	/* the character to kill the local line with */
